clear all; 
close all;

    g = 9.81;
    pa = 101325;            %Atmospheric pressure
    rho_c0 = 1.23;      
    rho_a = 1.23;
    gamma = 1.4;
    A33 = 0.533E+05;           
    B33 =  0.413E+04*1;              
    C33 = 0.1*0.358E+06; 
    A55 = (0.170E+07)*1;          
    B55 = (0.130E+06)*1;      
    C55 = 0.111E+08*1;        %1.3
    I55 = (0.438E+07)*1;    % 1.8
    Ac = 160;               %Lift area of cushion (20*8)
    h0 = 2;               %Equilibrium distance from cushion 'ceiling' to free water surface
    p0 = 200;              %Equilibrium uniform excess cushion pressure [mmWC]
    cn          = 0.610;       
    L           = 20; % Air Cushion length
    x_cp        = 0.5;                  % Distance from COG to centre of pressure
    x_cb        = 15;                  % Fr 12.5
    z_cb        = 4.3;                 % Noe annet fr               
    K_h         = 853333*1.3;          %Fr: 980 000, Frst: 1280000. Horizontal spring stiffnes. Java: 350000.0
    K_h_dot     = 8333;
    K_v         = 640000*1.0;          % FR: 2800 000. *8 Vertical spring stiffnes. Java: 350000.0
    K_v_dot     = 640000/10;    % FR: 875 000
    mu_k        = 0.75;              %Kinetic coefficient of friction, rubber-steel
    mu_s        = 0.85;              %Static coefficient of friction, rubber-steel
    x_0         = [-1.2 0 0 0 0 0 0 4.3 0]';     %Initial condition of the three DOF and their momentums
    m = 85000; 
    dQ = 69; % [m^3/s] Taken from fullscale lift fan characteristic
dp = -1410; % [mmWC].. Taken from fullscale lift fan characteristic
 

dQdp = dQ/dp;


Q0 = 45*2; % [m^3 / s]. Taken from fullscale lift fan characteristic
K1 = rho_c0 * h0*Ac/(gamma*(1+(pa/p0)));
K2 = rho_c0*cn * sqrt(2*p0/rho_a);
K3 = rho_c0 *(Q0/2-2*p0*dQdp);  % q = 2       %old: 2.5
k_b = 0;
k_c = 1;
kj = 0.1;
    
startcontrol = 200; %When BCS should start;
changewaves = 1000;   %Waves stop at this time
stopcontrol = 2500;
adapt_gain = 0.2; %adaptation gain

Hshigh = 1.4;
Hslow = 0.8;


%Irregular waves:
% load('irregwaves.mat')
% load('irregwavesreversed.mat')
% adapt_gain = 0.2; %adaptation gain
% Vwindhigh = 9;
% Vwindlow = 7.5;
% transition = 600;
% [elev,peakfreqlow,peakfreqhigh,Hshigh,Hslow]=runTest(Vwindlow,Vwindhigh,changewaves,transition);
% disp(peakfreqlow)
% disp(peakfreqhigh)
% ts = 0.1:0.0025:3000;
% irregwaves = timeseries(elev,ts);
% save irregwaves, 'times';
% 
% omega_0 = mean([peakfreqhigh,peakfreqlow]);
% k = omega_0^2/g;
% d = 1.2;             %draft sidehulls
% Wave_amp = mean([Hshigh,Hslow]);

% Vwindhigh = 10;
% Vwindlow = 12;
% transition = 600;
% [elev,peakfreqlow,peakfreqhigh,Hshigh,Hslow]=runTest(Vwindlow,Vwindhigh,changewaves,transition);
% disp(peakfreqlow)
% disp(peakfreqhigh)
% ts = 0.1:0.0025:3000;
% irregwavesreversed = timeseries(elev,ts);
% save irregwavesreversed, 'times';

% 
% 
% % Hs = calcHs(elev)
% % disp(peakfreq)changewaves 
% % ts = 0.1:0.0025:2000;
% % irregwaveshigh = timeseries(elev,ts);
% % save irregwaveshigh, 'times';
% 
% % Vwind = 14;
% % [elev,peakfreq]=runTest(Vwind);
% % Hs = calcHs(elev)
% % disp(peakfreq)
% % ts = 0.1:0.0025:2000;
% % irregwaveslow = timeseries(elev,ts);
% % save irregwaveslow, 'times';